Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Photoshop.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Photoshop.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Photoshop.pm	(revision 34921)
@@ -433,4 +983,5 @@
             Size    => $size,
             Start   => $pos,
+            Base    => $$dirInfo{Base},
             Parent  => $$dirInfo{DirName},
         );
@@ -438,4 +989,5 @@
         $pos += $size;
     }
+    delete $$et{LOW_PRIORITY_DIR}{'*'};
     return $success;
 }
@@ -447,5 +999,5 @@
 sub ProcessPSD($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $outfile = $$dirInfo{OutFile};
@@ -455,5 +1007,5 @@
     $data =~ /^8BPS\0([\x01\x02])/ or return 0;
     SetByteOrder('MM');
-    $exifTool->SetFileType($1 eq "\x01" ? 'PSD' : 'PSB'); # set the FileType tag
+    $et->SetFileType($1 eq "\x01" ? 'PSD' : 'PSB'); # set the FileType tag
     my %dirInfo = (
         DataPt => \$data,
@@ -467,12 +1019,13 @@
         Write($outfile, $data) or $err = 1; # write color mode data
         # initialize map of where things are written
-        $exifTool->InitWriteDirs(\%psdMap);
+        $et->InitWriteDirs(\%psdMap);
     } else {
         # process the header
         $tagTablePtr = GetTagTable('Image::ExifTool::Photoshop::Header');
         $dirInfo{DirLen} = 30;
-        $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+        $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         $raf->Seek($len, 1) or $err = 1;    # skip over color mode data
     }
+    # read image resource section
     $raf->Read($data, 4) == 4 or $err = 1;
     $len = Get32u(\$data, 0);
@@ -483,5 +1036,5 @@
     if ($outfile) {
         # rewrite IRB resources
-        $data = WritePhotoshop($exifTool, \%dirInfo, $tagTablePtr);
+        $data = WritePhotoshop($et, \%dirInfo, $tagTablePtr);
         if ($data) {
             $len = Set32u(length $data);
@@ -493,5 +1046,5 @@
                 $$trailInfo{OutFile} = \$tbuf;  # rewrite trailer(s)
                 # rewrite all trailers to buffer
-                if ($exifTool->ProcessTrailers($trailInfo)) {
+                if ($et->ProcessTrailers($trailInfo)) {
                     my $copyBytes = $$trailInfo{DataPos} - $raf->Tell();
                     if ($copyBytes >= 0) {
@@ -504,7 +1057,7 @@
                         }
                         # write the trailer (or not)
-                        $exifTool->WriteTrailerBuffer($trailInfo, $outfile) or $err = 1;
+                        $et->WriteTrailerBuffer($trailInfo, $outfile) or $err = 1;
                     } else {
-                        $exifTool->Warn('Overlapping trailer');
+                        $et->Warn('Overlapping trailer');
                         undef $trailInfo;
                     }
@@ -524,10 +1077,28 @@
         $rtnVal = -1 if $err;
     } elsif ($err) {
-        $exifTool->Warn('File format error');
+        $et->Warn('File format error');
     } else {
-        ProcessPhotoshop($exifTool, \%dirInfo, $tagTablePtr);
+        # read IRB resources
+        ProcessPhotoshop($et, \%dirInfo, $tagTablePtr);
+        # read layer and mask information section
+        $dirInfo{RAF} = $raf;
+        $tagTablePtr = GetTagTable('Image::ExifTool::Photoshop::Layers');
+        my $oldIndent = $$et{INDENT};
+        $$et{INDENT} .= '| ';
+        if (ProcessLayersAndMask($et, \%dirInfo, $tagTablePtr) and
+            # read compression mode from image data section
+            $raf->Read($data,2) == 2)
+        {
+            my %dirInfo = (
+                DataPt  => \$data,
+                DataPos => $raf->Tell() - 2,
+            );
+            $tagTablePtr = GetTagTable('Image::ExifTool::Photoshop::ImageData');
+            $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
+        }
+        $$et{INDENT} = $oldIndent;
         # process trailers if they exist
         my $trailInfo = Image::ExifTool::IdentifyTrailer($raf);
-        $exifTool->ProcessTrailers($trailInfo) if $trailInfo;
+        $et->ProcessTrailers($trailInfo) if $trailInfo;
     }
     return $rtnVal;
@@ -567,5 +1138,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -583,4 +1154,6 @@
 
 =item L<http://libpsd.graphest.com/files/Photoshop%20File%20Formats.pdf>
+
+=item L<http://www.adobe.com/devnet-apps/photoshop/fileformatashtml/>
 
 =back
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/PostScript.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/PostScript.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/PostScript.pm	(revision 34921)
@@ -17,5 +17,5 @@
 use Image::ExifTool qw(:DataAccess :Utils);
 
-$VERSION = '1.33';
+$VERSION = '1.44';
 
 sub WritePS($$);
@@ -39,4 +39,5 @@
         Writable => 'string',
         PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val)',
     },
     Creator     => { Priority => 0, Writable => 'string' },
@@ -50,4 +51,5 @@
         Writable => 'string',
         PrintConv => '$self->ConvertDateTime($val)',
+        PrintConvInv => '$self->InverseDateTime($val)',
     },
     Pages       => { Priority => 0 },
@@ -76,4 +78,5 @@
     },
     TIFFPreview => {
+        Groups => { 2 => 'Preview' },
         Binary => 1,
         Notes => q{
@@ -87,12 +90,37 @@
             TagTable => 'Image::ExifTool::PostScript::Main',
         },
-        Notes => 'extracted with ExtractEmbedded option',
+        Notes => 'extracted with L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> option',
     },
     EmbeddedFileName => {
         Notes => q{
             not a real tag ID, but the file name from a BeginDocument statement.
-            Extracted with document metadata when ExtractEmbedded option is used
-        },
-    },
+            Extracted with document metadata when L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> option is used
+        },
+    },
+    # AI metadata (most with a single leading '%')
+    AI9_ColorModel => {
+        Name => 'AIColorModel',
+        PrintConv => {
+            1 => 'RGB',
+            2 => 'CMYK',
+        },
+    },
+    AI3_ColorUsage       => { Name => 'AIColorUsage' },
+    AI5_RulerUnits       => {
+        Name => 'AIRulerUnits',
+        PrintConv => {
+            0 => 'Inches',
+            1 => 'Millimeters',
+            2 => 'Points',
+            3 => 'Picas',
+            4 => 'Centimeters',
+            6 => 'Pixels',
+        },
+    },
+    AI5_TargetResolution => { Name => 'AITargetResolution' },
+    AI5_NumLayers        => { Name => 'AINumLayers' },
+    AI5_FileFormat       => { Name => 'AIFileFormat' },
+    AI8_CreatorVersion   => { Name => 'AICreatorVersion' }, # (double leading '%')
+    AI12_BuildNumber     => { Name => 'AIBuildNumber' },
 );
 
@@ -159,9 +187,9 @@
 sub PSErr($$)
 {
-    my ($exifTool, $str) = @_;
+    my ($et, $str) = @_;
     # set file type if not done already
-    my $ext = $$exifTool{FILE_EXT};
-    $exifTool->SetFileType(($ext and $ext eq 'AI') ? 'AI' : 'PS');
-    $exifTool->Warn("PostScript format error ($str)");
+    my $ext = $$et{FILE_EXT};
+    $et->SetFileType(($ext and $ext eq 'AI') ? 'AI' : 'PS');
+    $et->Warn("PostScript format error ($str)");
     return 1;
 }
@@ -181,7 +209,7 @@
     $d = pos($data) if $data =~ /\x0d/g;
     my $diff = $a - $d;
-    if ($diff eq 1) {
+    if ($diff == 1) {
         $sep = "\x0d\x0a";
-    } elsif ($diff eq -1) {
+    } elsif ($diff == -1) {
         $sep = "\x0a\x0d";
     } elsif ($diff > 0) {
@@ -195,4 +223,95 @@
 
 #------------------------------------------------------------------------------
+# Split into lines ending in any CR, LF or CR+LF combination
+# (this is annoying, and could be avoided if EPS files didn't mix linefeeds!)
+# Inputs: 0) data pointer, 1) reference to lines array
+# Notes: Fills @$lines with lines from splitting $$dataPt
+sub SplitLine($$)
+{
+    my ($dataPt, $lines) = @_;
+    for (;;) {
+        my $endl;
+        # find the position of the first LF (\x0a)
+        $endl = pos($$dataPt), pos($$dataPt) = 0 if $$dataPt =~ /\x0a/g;
+        if ($$dataPt =~ /\x0d/g) { # find the first CR (\x0d)
+            if (defined $endl) {
+                # (remember, CR+LF is a DOS newline...)
+                $endl = pos($$dataPt) if pos($$dataPt) < $endl - 1;
+            } else {
+                $endl = pos($$dataPt);
+            }
+        } elsif (not defined $endl) {
+            push @$lines, $$dataPt;
+            last;
+        }
+        if (length $$dataPt == $endl) {
+            push @$lines, $$dataPt;
+            last;
+        } else {
+            # continue to split into separate lines
+            push @$lines, substr($$dataPt, 0, $endl);
+            $$dataPt = substr($$dataPt, $endl);
+        }
+    }
+}
+
+#------------------------------------------------------------------------------
+# check to be sure we haven't read past end of PS data in DOS-style file
+# Inputs: 0) RAF ref (with PSEnd member), 1) data ref
+# - modifies data and sets RAF to EOF if end of PS is reached
+sub CheckPSEnd($$)
+{
+    my ($raf, $dataPt) = @_;
+    my $pos = $raf->Tell();
+    if ($pos >= $$raf{PSEnd}) {
+        $raf->Seek(0, 2);   # seek to end of file so we can't read any more
+        $$dataPt = substr($$dataPt, 0, length($$dataPt) - $pos + $$raf{PSEnd}) if $pos > $$raf{PSEnd};
+    }
+}
+
+#------------------------------------------------------------------------------
+# Read next line from EPS file
+# Inputs: 0) RAF ref (with PSEnd member if Postscript ends before end of file)
+#         1) array of lines from file
+# Returns: true on success
+sub GetNextLine($$)
+{
+    my ($raf, $lines) = @_;
+    my ($data, $changedNL);
+    my $altnl = ($/ eq "\x0d") ? "\x0a" : "\x0d";
+    for (;;) {
+        $raf->ReadLine($data) or last;
+        $$raf{PSEnd} and CheckPSEnd($raf, \$data);
+        # split line if it contains other newline sequences
+        if ($data =~ /$altnl/) {
+            if (length($data) > 500000 and IsPC()) {
+                # patch for Windows memory problem
+                unless ($changedNL) {
+                    $changedNL = $/;
+                    $/ = $altnl;
+                    $altnl = $changedNL;
+                    $raf->Seek(-length($data), 1);
+                    next;
+                }
+            } else {
+                    # split into separate lines
+                #    push @$lines, split /$altnl/, $data, -1;
+                #    if (@$lines == 2 and $$lines[1] eq $/) {
+                #        # handle case of DOS newline data inside file using Unix newlines
+                #        $$lines[0] .= pop @$lines;
+                #    }
+                # split into separate lines if necessary
+               SplitLine(\$data, $lines);
+            }
+        } else {
+            push @$lines, $data;
+        }
+        $/ = $changedNL if $changedNL;
+        return 1;
+    }
+    return 0;
+}
+
+#------------------------------------------------------------------------------
 # Decode comment from PostScript file
 # Inputs: 0) comment string, 1) RAF ref, 2) reference to lines array
@@ -206,17 +325,5 @@
     # check for continuation comments
     for (;;) {
-        unless (@$lines) {
-            my $buff;
-            $raf->ReadLine($buff) or last;
-            my $altnl = $/ eq "\x0d" ? "\x0a" : "\x0d";
-            if ($buff =~ /$altnl/) {
-                # split into separate lines
-                @$lines = split /$altnl/, $buff, -1;
-                # handle case of DOS newline data inside file using Unix newlines
-                @$lines = ( $$lines[0] . $$lines[1] ) if @$lines == 2 and $$lines[1] eq $/;
-            } else {
-                push @$lines, $buff;
-            }
-        }
+        @$lines or GetNextLine($raf, $lines) or last;
         last unless $$lines[0] =~ /^%%\+/;  # is the next line a continuation?
         $$dataPt .= $$lines[0] if $dataPt;  # add to data if necessary
@@ -317,11 +424,14 @@
 sub ProcessPS($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $raf = $$dirInfo{RAF};
-    my $embedded = $exifTool->Options('ExtractEmbedded');
+    my $embedded = $et->Options('ExtractEmbedded');
     my ($data, $dos, $endDoc, $fontTable, $comment);
 
     # allow read from data
-    $raf = new File::RandomAccess($$dirInfo{DataPt}) unless $raf;
+    unless ($raf) {
+        $raf = new File::RandomAccess($$dirInfo{DataPt});
+        $et->VerboseDir('PostScript');
+    }
 #
 # determine if this is a postscript file
@@ -338,9 +448,11 @@
         $raf->Read($dos, 26) == 26 or return 0;
         SetByteOrder('II');
-        unless ($raf->Seek(Get32u(\$dos, 0), 0) and
+        my $psStart = Get32u(\$dos, 0);
+        unless ($raf->Seek($psStart, 0) and
                 $raf->Read($data, 4) == 4 and $data eq '%!PS')
         {
-            return PSErr($exifTool, 'invalid header');
-        }
+            return PSErr($et, 'invalid header');
+        }
+        $$raf{PSEnd} = $psStart + Get32u(\$dos, 4); # set end of PostScript data in RAF
     } else {
         # check for PostScript font file (PFA or PFB)
@@ -348,5 +460,5 @@
         $data .= $d2 if $raf->Read($d2,12);
         if ($data =~ /^%!(PS-(AdobeFont-|Bitstream )|FontType1-)/) {
-            $exifTool->SetFileType('PFA');  # PostScript ASCII font file
+            $et->SetFileType('PFA');  # PostScript ASCII font file
             $fontTable = GetTagTable('Image::ExifTool::Font::PSInfo');
             # PostScript font files may contain an unformatted comments which may
@@ -360,5 +472,5 @@
 #
     local $/ = GetInputRecordSeparator($raf);
-    $/ or return PSErr($exifTool, 'invalid PS data');
+    $/ or return PSErr($et, 'invalid PS data');
 
     # set file type (PostScript or EPS)
@@ -378,5 +490,6 @@
         $raf->Seek($pos, 0);
     }
-    $exifTool->SetFileType($type);
+    $et->SetFileType($type);
+    return 1 if $$et{OPTIONS}{FastScan} and $$et{OPTIONS}{FastScan} == 3;
 #
 # extract TIFF information from DOS header
@@ -389,9 +502,9 @@
             # extract the TIFF preview
             my $len = Get32u(\$dos, 20);
-            my $val = $exifTool->ExtractBinary($base, $len, 'TIFFPreview');
+            my $val = $et->ExtractBinary($base, $len, 'TIFFPreview');
             if (defined $val and $val =~ /^(MM\0\x2a|II\x2a\0|Binary)/) {
-                $exifTool->HandleTag($tagTablePtr, 'TIFFPreview', $val);
+                $et->HandleTag($tagTablePtr, 'TIFFPreview', $val);
             } else {
-                $exifTool->Warn('Bad TIFF preview image');
+                $et->Warn('Bad TIFF preview image');
             }
             # extract information from TIFF in DOS header
@@ -402,5 +515,5 @@
                 Base => $base,
             );
-            $exifTool->ProcessTIFF(\%dirInfo) or $exifTool->Warn('Bad embedded TIFF');
+            $et->ProcessTIFF(\%dirInfo) or $et->Warn('Bad embedded TIFF');
             # position file pointer to extract PS information
             $raf->Seek($pos, 0);
@@ -453,5 +566,5 @@
             if (not $endToken) {
                 $buff .= $data;
-                next unless $data =~ m{<\?xpacket end=.(w|r).\?>($/|$)};
+                next unless $data =~ m{<\?xpacket end=.(w|r).\?>(\n|\r|$)};
             } elsif ($data !~ /^$endToken/i) {
                 if ($mode eq 'XMP') {
@@ -475,5 +588,5 @@
             $docNum =~ s/-?(\d+)$//;        # decrement nesting level
             $subDocNum = $1;                # remember our last sub-document number
-            $$exifTool{DOC_NUM} = $docNum;
+            $$et{DOC_NUM} = $docNum;
             undef $endDoc unless $docNum;   # done with document if top level
             next;
@@ -504,12 +617,12 @@
                 } else {
                     # this is the Nth document
-                    $docNum = $$exifTool{DOC_COUNT} + 1;
+                    $docNum = $$et{DOC_COUNT} + 1;
                 }
                 $subDocNum = 0; # new level, so reset subDocNum
                 next unless $embedded;  # skip over this document
                 # set document number for family 4-7 group names
-                $$exifTool{DOC_NUM} = $docNum;
-                $$exifTool{LIST_TAGS} = { };  # don't build lists across different documents
-                $exifTool->{PROCESSED} = { }; # re-initialize processed directory lookup too
+                $$et{DOC_NUM} = $docNum;
+                $$et{LIST_TAGS} = { };  # don't build lists across different documents
+                $$et{PROCESSED} = { }; # re-initialize processed directory lookup too
                 $endDoc = $endToken;          # parse to EndDocument token
                 # reset mode to allow parsing into sub-directories
@@ -521,5 +634,5 @@
                     # remove brackets if necessary
                     $docName = $1 if $docName =~ /^\((.*)\)$/;
-                    $exifTool->HandleTag($tagTablePtr, 'EmbeddedFileName', $docName);
+                    $et->HandleTag($tagTablePtr, 'EmbeddedFileName', $docName);
                 }
             }
@@ -531,17 +644,17 @@
             undef $endToken;    # no end token (just look for xpacket end)
             # XMP could be contained in a single line (if newlines are different)
-            next unless $data =~ m{<\?xpacket end=.(w|r).\?>($/|$)};
+            next unless $data =~ m{<\?xpacket end=.(w|r).\?>(\n|\r|$)};
         } elsif ($data =~ /^%%?(\w+): ?(.*)/s and $$tagTablePtr{$1}) {
             my ($tag, $val) = ($1, $2);
-            # only allow 'ImageData' to have single leading '%'
-            next unless $data =~ /^%%/ or $1 eq 'ImageData';
+            # only allow 'ImageData' and AI tags to have single leading '%'
+            next unless $data =~ /^%(%|AI\d+_)/ or $tag eq 'ImageData';
             # decode comment string (reading continuation lines if necessary)
             $val = DecodeComment($val, $raf, \@lines);
-            $exifTool->HandleTag($tagTablePtr, $tag, $val);
+            $et->HandleTag($tagTablePtr, $tag, $val);
             next;
         } elsif ($embedded and $data =~ /^%AI12_CompressedData/) {
             # the rest of the file is compressed
-            unless (eval 'require Compress::Zlib') {
-                $exifTool->Warn('Install Compress::Zlib to extract compressed embedded data');
+            unless (eval { require Compress::Zlib }) {
+                $et->Warn('Install Compress::Zlib to extract compressed embedded data');
                 last;
             }
@@ -554,10 +667,10 @@
             last unless $data =~ s/.*?%AI12_CompressedData//;
             my $inflate = Compress::Zlib::inflateInit();
-            $inflate or $exifTool->Warn('Error initializing inflate'), last;
+            $inflate or $et->Warn('Error initializing inflate'), last;
             # generate a PS-like file in memory from the compressed data
-            my $verbose = $exifTool->Options('Verbose');
+            my $verbose = $et->Options('Verbose');
             if ($verbose > 1) {
-                $exifTool->VerboseDir('AI12_CompressedData (first 4kB)');
-                $exifTool->VerboseDump(\$data);
+                $et->VerboseDir('AI12_CompressedData (first 4kB)');
+                $et->VerboseDump(\$data);
             }
             # remove header if it exists (Windows AI files only)
@@ -578,12 +691,12 @@
                 $raf->Read($data, 65536) or last;
             }
-            defined $val or $exifTool->Warn('Error inflating AI compressed data'), last;
+            defined $val or $et->Warn('Error inflating AI compressed data'), last;
             if ($verbose > 1) {
-                $exifTool->VerboseDir('Uncompressed AI12 Data');
-                $exifTool->VerboseDump(\$val);
+                $et->VerboseDir('Uncompressed AI12 Data');
+                $et->VerboseDump(\$val);
             }
             # extract information from embedded images in the uncompressed data
             $val =  # add PS header in case it needs one
-            ProcessPS($exifTool, { DataPt => \$val });
+            ProcessPS($et, { DataPt => \$val });
             last;
         } elsif ($fontTable) {
@@ -596,5 +709,5 @@
                 } elsif ($data !~ /^%/) {
                     # stop extracting comments at the first non-comment line
-                    $exifTool->FoundTag('Comment', $comment) if length $comment;
+                    $et->FoundTag('Comment', $comment) if length $comment;
                     undef $comment;
                 }
@@ -607,5 +720,5 @@
                     $val = $1;
                 }
-                $exifTool->HandleTag($fontTable, $tag, $val);
+                $et->HandleTag($fontTable, $tag, $val);
             } elsif ($data =~ /^currentdict end/) {
                 # only extract tags from initial FontInfo dict
@@ -625,6 +738,6 @@
         );
         my $subTablePtr = GetTagTable("Image::ExifTool::${mode}::Main");
-        unless ($exifTool->ProcessDirectory(\%dirInfo, $subTablePtr)) {
-            $exifTool->Warn("Error processing $mode information in PostScript file");
+        unless ($et->ProcessDirectory(\%dirInfo, $subTablePtr)) {
+            $et->Warn("Error processing $mode information in PostScript file");
         }
         undef $buff;
@@ -632,5 +745,5 @@
     }
     $mode = 'Document' if $endDoc and not $mode;
-    $mode and PSErr($exifTool, "unterminated $mode data");
+    $mode and PSErr($et, "unterminated $mode data");
     return 1;
 }
@@ -665,5 +778,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/PrintIM.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/PrintIM.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/PrintIM.pm	(revision 34921)
@@ -13,5 +13,5 @@
 use Image::ExifTool qw(:DataAccess);
 
-$VERSION = '1.06';
+$VERSION = '1.07';
 
 sub ProcessPrintIM($$$);
@@ -43,20 +43,20 @@
 sub ProcessPrintIM($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
     my $offset = $$dirInfo{DirStart};
     my $size = $$dirInfo{DirLen};
-    my $verbose = $exifTool->Options('Verbose');
+    my $verbose = $et->Options('Verbose');
 
     unless ($size) {
-        $exifTool->Warn('Empty PrintIM data', 1);
+        $et->Warn('Empty PrintIM data', 1);
         return 0;
     }
     unless ($size > 15) {
-        $exifTool->Warn('Bad PrintIM data');
+        $et->Warn('Bad PrintIM data');
         return 0;
     }
     unless (substr($$dataPt, $offset, 7) eq 'PrintIM') {
-        $exifTool->Warn('Invalid PrintIM header');
+        $et->Warn('Invalid PrintIM header');
         return 0;
     }
@@ -68,10 +68,10 @@
         $num = Get16u($dataPt, $offset + 14);
         if ($size < 16 + $num * 6) {
-            $exifTool->Warn('Bad PrintIM size');
+            $et->Warn('Bad PrintIM size');
             return 0;
         }
     }
-    $verbose and $exifTool->VerboseDir('PrintIM', $num);
-    $exifTool->HandleTag($tagTablePtr, 'PrintIMVersion', substr($$dataPt, $offset + 8, 4),
+    $verbose and $et->VerboseDir('PrintIM', $num);
+    $et->HandleTag($tagTablePtr, 'PrintIMVersion', substr($$dataPt, $offset + 8, 4),
         DataPt => $dataPt,
         Start  => $offset + 8,
@@ -83,5 +83,5 @@
         my $tag = Get16u($dataPt, $pos);
         my $val = Get32u($dataPt, $pos + 2);
-        $exifTool->HandleTag($tagTablePtr, $tag, $val,
+        $et->HandleTag($tagTablePtr, $tag, $val,
             Index  => $n,
             DataPt => $dataPt,
@@ -113,5 +113,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
